# Solarus library source files.
file(
  GLOB
  solarus_SOURCES

  include/solarus/containers/Grid.h
  include/solarus/containers/Quadtree.h
  include/solarus/containers/Quadtree.inl

  include/solarus/entities/AnimatedTilePattern.h
  include/solarus/entities/Arrow.h
  include/solarus/entities/Block.h
  include/solarus/entities/Bomb.h
  include/solarus/entities/Boomerang.h
  include/solarus/entities/Camera.h
  include/solarus/entities/CameraPtr.h
  include/solarus/entities/CarriedObject.h
  include/solarus/entities/Chest.h
  include/solarus/entities/CollisionMode.h
  include/solarus/entities/CrystalBlock.h
  include/solarus/entities/Crystal.h
  include/solarus/entities/CustomEntity.h
  include/solarus/entities/Destination.h
  include/solarus/entities/Destructible.h
  include/solarus/entities/Door.h
  include/solarus/entities/DynamicTile.h
  include/solarus/entities/EnemyAttack.h
  include/solarus/entities/Enemy.h
  include/solarus/entities/EnemyReaction.h
  include/solarus/entities/Entities.h
  include/solarus/entities/Entity.h
  include/solarus/entities/EntityPtr.h
  include/solarus/entities/EntityState.h
  include/solarus/entities/EntityType.h
  include/solarus/entities/EntityTypeInfo.h
  include/solarus/entities/Explosion.h
  include/solarus/entities/Fire.h
  include/solarus/entities/Ground.h
  include/solarus/entities/GroundInfo.h
  include/solarus/entities/Hero.h
  include/solarus/entities/HeroPtr.h
  include/solarus/entities/Hookshot.h
  include/solarus/entities/Jumper.h
  include/solarus/entities/Layer.h
  include/solarus/entities/NonAnimatedRegions.h
  include/solarus/entities/Npc.h
  include/solarus/entities/ParallaxScrollingTilePattern.h
  include/solarus/entities/Pickable.h
  include/solarus/entities/SelfScrollingTilePattern.h
  include/solarus/entities/Sensor.h
  include/solarus/entities/Separator.h
  include/solarus/entities/SeparatorPtr.h
  include/solarus/entities/ShopTreasure.h
  include/solarus/entities/SimpleTilePattern.h
  include/solarus/entities/Stairs.h
  include/solarus/entities/StartingLocationMode.h
  include/solarus/entities/StreamAction.h
  include/solarus/entities/Stream.h
  include/solarus/entities/Switch.h
  include/solarus/entities/Teletransporter.h
  include/solarus/entities/Tile.h
  include/solarus/entities/TileInfo.h
  include/solarus/entities/TilePattern.h
  include/solarus/entities/TilePtr.h
  include/solarus/entities/TilesetData.h
  include/solarus/entities/Tileset.h
  include/solarus/entities/TimeScrollingTilePattern.h
  include/solarus/entities/Wall.h

  include/solarus/hero/BackToSolidGroundState.h
  include/solarus/hero/BoomerangState.h
  include/solarus/hero/BowState.h
  include/solarus/hero/CarryingState.h
  include/solarus/hero/FallingState.h
  include/solarus/hero/ForcedWalkingState.h
  include/solarus/hero/FreeState.h
  include/solarus/hero/FrozenState.h
  include/solarus/hero/GrabbingState.h
  include/solarus/hero/HeroSprites.h
  include/solarus/hero/HeroState.h
  include/solarus/hero/HookshotState.h
  include/solarus/hero/HurtState.h
  include/solarus/hero/JumpingState.h
  include/solarus/hero/LiftingState.h
  include/solarus/hero/PlayerMovementState.h
  include/solarus/hero/PlungingState.h
  include/solarus/hero/PullingState.h
  include/solarus/hero/PushingState.h
  include/solarus/hero/RunningState.h
  include/solarus/hero/SpinAttackState.h
  include/solarus/hero/StairsState.h
  include/solarus/hero/SwimmingState.h
  include/solarus/hero/SwordLoadingState.h
  include/solarus/hero/SwordSwingingState.h
  include/solarus/hero/SwordTappingState.h
  include/solarus/hero/TreasureState.h
  include/solarus/hero/UsingItemState.h
  include/solarus/hero/VictoryState.h

  include/solarus/lowlevel/apple/AppleInterface.h
  include/solarus/lowlevel/BlendMode.h
  include/solarus/lowlevel/BlendModeInfo.h
  include/solarus/lowlevel/Color.h
  include/solarus/lowlevel/Debug.h
  include/solarus/lowlevel/FontResource.h
  include/solarus/lowlevel/Geometry.h
  include/solarus/lowlevel/Hq2xFilter.h
  include/solarus/lowlevel/Hq3xFilter.h
  include/solarus/lowlevel/Hq4xFilter.h
  include/solarus/lowlevel/InputEvent.h
  include/solarus/lowlevel/ItDecoder.h
  include/solarus/lowlevel/Logger.h
  include/solarus/lowlevel/Music.h
  include/solarus/lowlevel/OggDecoder.h
  include/solarus/lowlevel/PixelBits.h
  include/solarus/lowlevel/PixelFilter.h
  include/solarus/lowlevel/Point.h
  include/solarus/lowlevel/Point.inl
  include/solarus/lowlevel/QuestFiles.h
  include/solarus/lowlevel/Random.h
  include/solarus/lowlevel/Rectangle.h
  include/solarus/lowlevel/Scale2xFilter.h
  include/solarus/lowlevel/shaders/GL_2DShader.h
  include/solarus/lowlevel/shaders/GL_ARBShader.h
  include/solarus/lowlevel/shaders/GLContext.h
  include/solarus/lowlevel/shaders/ShaderContext.h
  include/solarus/lowlevel/shaders/Shader.h
  include/solarus/lowlevel/Size.h
  include/solarus/lowlevel/Size.inl
  include/solarus/lowlevel/Sound.h
  include/solarus/lowlevel/SpcDecoder.h
  include/solarus/lowlevel/String.h
  include/solarus/lowlevel/Surface.h
  include/solarus/lowlevel/SurfacePtr.h
  include/solarus/lowlevel/System.h
  include/solarus/lowlevel/TextSurface.h
  include/solarus/lowlevel/Video.h
  include/solarus/lowlevel/VideoMode.h

  include/solarus/lua/ExportableToLua.h
  include/solarus/lua/ExportableToLuaPtr.h
  include/solarus/lua/LuaContext.h
  include/solarus/lua/LuaData.h
  include/solarus/lua/LuaException.h
  include/solarus/lua/LuaTools.h
  include/solarus/lua/LuaTools.inl
  include/solarus/lua/ScopedLuaRef.h

  include/solarus/movements/CircleMovement.h
  include/solarus/movements/FallingHeight.h
  include/solarus/movements/FallingOnFloorMovement.h
  include/solarus/movements/JumpMovement.h
  include/solarus/movements/Movement.h
  include/solarus/movements/PathFinding.h
  include/solarus/movements/PathFindingMovement.h
  include/solarus/movements/PathMovement.h
  include/solarus/movements/PixelMovement.h
  include/solarus/movements/PlayerMovement.h
  include/solarus/movements/RandomMovement.h
  include/solarus/movements/RandomPathMovement.h
  include/solarus/movements/RelativeMovement.h
  include/solarus/movements/StraightMovement.h
  include/solarus/movements/TargetMovement.h

  include/solarus/third_party/hqx/common.h
  include/solarus/third_party/hqx/hqx.h
  include/solarus/third_party/snes_spc/blargg_common.h
  include/solarus/third_party/snes_spc/blargg_config.h
  include/solarus/third_party/snes_spc/blargg_endian.h
  include/solarus/third_party/snes_spc/blargg_source.h
  include/solarus/third_party/snes_spc/dsp.h
  include/solarus/third_party/snes_spc/SNES_SPC.h
  include/solarus/third_party/snes_spc/SPC_CPU.h
  include/solarus/third_party/snes_spc/SPC_DSP.h
  include/solarus/third_party/snes_spc/SPC_Filter.h
  include/solarus/third_party/snes_spc/spc.h

  include/solarus/Ability.h
  include/solarus/AbilityInfo.h
  include/solarus/Arguments.h
  include/solarus/CommandsEffects.h
  include/solarus/Common.h
  include/solarus/config.h
  include/solarus/CurrentQuest.h
  include/solarus/DialogBoxSystem.h
  include/solarus/Dialog.h
  include/solarus/DialogResources.h
  include/solarus/Drawable.h
  include/solarus/DrawablePtr.h
  include/solarus/EntityData.h
  include/solarus/EnumInfo.h
  include/solarus/EnumInfo.inl
  include/solarus/Equipment.h
  include/solarus/EquipmentItem.h
  include/solarus/EquipmentItemUsage.h
  include/solarus/GameCommand.h
  include/solarus/GameCommands.h
  include/solarus/Game.h
  include/solarus/MainLoop.h
  include/solarus/Map.h
  include/solarus/MapData.h
  include/solarus/QuestProperties.h
  include/solarus/QuestResources.h
  include/solarus/ResourceType.h
  include/solarus/SavegameConverterV1.h
  include/solarus/Savegame.h
  include/solarus/Settings.h
  include/solarus/SolarusFatal.h
  include/solarus/SpriteAnimationDirection.h
  include/solarus/SpriteAnimation.h
  include/solarus/SpriteAnimationSet.h
  include/solarus/Sprite.h
  include/solarus/SpriteData.h
  include/solarus/SpritePtr.h
  include/solarus/StringResources.h
  include/solarus/Timer.h
  include/solarus/TimerPtr.h
  include/solarus/TransitionFade.h
  include/solarus/Transition.h
  include/solarus/TransitionImmediate.h
  include/solarus/TransitionScrolling.h
  include/solarus/Treasure.h

  src/entities/AnimatedTilePattern.cpp
  src/entities/Arrow.cpp
  src/entities/Block.cpp
  src/entities/Bomb.cpp
  src/entities/Boomerang.cpp
  src/entities/Camera.cpp
  src/entities/CarriedObject.cpp
  src/entities/Chest.cpp
  src/entities/CrystalBlock.cpp
  src/entities/Crystal.cpp
  src/entities/CustomEntity.cpp
  src/entities/Destination.cpp
  src/entities/Destructible.cpp
  src/entities/Door.cpp
  src/entities/DynamicTile.cpp
  src/entities/Enemy.cpp
  src/entities/EnemyReaction.cpp
  src/entities/Entities.cpp
  src/entities/Entity.cpp
  src/entities/EntityState.cpp
  src/entities/EntityTypeInfo.cpp
  src/entities/Explosion.cpp
  src/entities/Fire.cpp
  src/entities/GroundInfo.cpp
  src/entities/Hero.cpp
  src/entities/Hookshot.cpp
  src/entities/Jumper.cpp
  src/entities/NonAnimatedRegions.cpp
  src/entities/Npc.cpp
  src/entities/ParallaxScrollingTilePattern.cpp
  src/entities/Pickable.cpp
  src/entities/SelfScrollingTilePattern.cpp
  src/entities/Sensor.cpp
  src/entities/Separator.cpp
  src/entities/ShopTreasure.cpp
  src/entities/SimpleTilePattern.cpp
  src/entities/Stairs.cpp
  src/entities/StartingLocationMode.cpp
  src/entities/StreamAction.cpp
  src/entities/Stream.cpp
  src/entities/Switch.cpp
  src/entities/Teletransporter.cpp
  src/entities/Tile.cpp
  src/entities/TilePattern.cpp
  src/entities/Tileset.cpp
  src/entities/TilesetData.cpp
  src/entities/TimeScrollingTilePattern.cpp
  src/entities/Wall.cpp

  src/hero/BackToSolidGroundState.cpp
  src/hero/BoomerangState.cpp
  src/hero/BowState.cpp
  src/hero/CarryingState.cpp
  src/hero/FallingState.cpp
  src/hero/ForcedWalkingState.cpp
  src/hero/FreeState.cpp
  src/hero/FrozenState.cpp
  src/hero/GrabbingState.cpp
  src/hero/HeroSprites.cpp
  src/hero/HeroState.cpp
  src/hero/HookshotState.cpp
  src/hero/HurtState.cpp
  src/hero/JumpingState.cpp
  src/hero/LiftingState.cpp
  src/hero/PlayerMovementState.cpp
  src/hero/PlungingState.cpp
  src/hero/PullingState.cpp
  src/hero/PushingState.cpp
  src/hero/RunningState.cpp
  src/hero/SpinAttackState.cpp
  src/hero/StairsState.cpp
  src/hero/SwimmingState.cpp
  src/hero/SwordLoadingState.cpp
  src/hero/SwordSwingingState.cpp
  src/hero/SwordTappingState.cpp
  src/hero/TreasureState.cpp
  src/hero/UsingItemState.cpp
  src/hero/VictoryState.cpp

  src/lowlevel/BlendModeInfo.cpp
  src/lowlevel/Color.cpp
  src/lowlevel/Debug.cpp
  src/lowlevel/FontResource.cpp
  src/lowlevel/Geometry.cpp
  src/lowlevel/Hq2xFilter.cpp
  src/lowlevel/Hq3xFilter.cpp
  src/lowlevel/Hq4xFilter.cpp
  src/lowlevel/InputEvent.cpp
  src/lowlevel/ItDecoder.cpp
  src/lowlevel/Logger.cpp
  src/lowlevel/Music.cpp
  src/lowlevel/OggDecoder.cpp
  src/lowlevel/PixelBits.cpp
  src/lowlevel/PixelFilter.cpp
  src/lowlevel/Point.cpp
  src/lowlevel/QuestFiles.cpp
  src/lowlevel/Random.cpp
  src/lowlevel/Rectangle.cpp
  src/lowlevel/Scale2xFilter.cpp
  src/lowlevel/shaders/GL_2DShader.cpp
  src/lowlevel/shaders/GL_ARBShader.cpp
  src/lowlevel/shaders/GLContext.cpp
  src/lowlevel/shaders/ShaderContext.cpp
  src/lowlevel/shaders/Shader.cpp
  src/lowlevel/Size.cpp
  src/lowlevel/Sound.cpp
  src/lowlevel/SpcDecoder.cpp
  src/lowlevel/String.cpp
  src/lowlevel/Surface.cpp
  src/lowlevel/System.cpp
  src/lowlevel/TextSurface.cpp
  src/lowlevel/Video.cpp
  src/lowlevel/VideoMode.cpp

  src/lua/AudioApi.cpp
  src/lua/DrawableApi.cpp
  src/lua/EntityApi.cpp
  src/lua/ExportableToLua.cpp
  src/lua/FileApi.cpp
  src/lua/GameApi.cpp
  src/lua/InputApi.cpp
  src/lua/ItemApi.cpp
  src/lua/LanguageApi.cpp
  src/lua/LuaContext.cpp
  src/lua/LuaData.cpp
  src/lua/LuaException.cpp
  src/lua/LuaTools.cpp
  src/lua/MainApi.cpp
  src/lua/MapApi.cpp
  src/lua/MenuApi.cpp
  src/lua/MovementApi.cpp
  src/lua/ScopedLuaRef.cpp
  src/lua/SpriteApi.cpp
  src/lua/SurfaceApi.cpp
  src/lua/TextSurfaceApi.cpp
  src/lua/TimerApi.cpp
  src/lua/VideoApi.cpp

  src/movements/CircleMovement.cpp
  src/movements/FallingOnFloorMovement.cpp
  src/movements/JumpMovement.cpp
  src/movements/Movement.cpp
  src/movements/PathFinding.cpp
  src/movements/PathFindingMovement.cpp
  src/movements/PathMovement.cpp
  src/movements/PixelMovement.cpp
  src/movements/PlayerMovement.cpp
  src/movements/RandomMovement.cpp
  src/movements/RandomPathMovement.cpp
  src/movements/RelativeMovement.cpp
  src/movements/StraightMovement.cpp
  src/movements/TargetMovement.cpp

  src/AbilityInfo.cpp
  src/Arguments.cpp
  src/CommandsEffects.cpp
  src/CurrentQuest.cpp
  src/DialogBoxSystem.cpp
  src/Dialog.cpp
  src/DialogResources.cpp
  src/Drawable.cpp
  src/EntityData.cpp
  src/Equipment.cpp
  src/EquipmentItem.cpp
  src/EquipmentItemUsage.cpp
  src/GameCommands.cpp
  src/Game.cpp
  src/MainLoop.cpp
  src/Map.cpp
  src/MapData.cpp
  src/QuestProperties.cpp
  src/QuestResources.cpp
  src/SavegameConverterV1.cpp
  src/Savegame.cpp
  src/Settings.cpp
  src/SolarusFatal.cpp
  src/SpriteAnimation.cpp
  src/SpriteAnimationDirection.cpp
  src/SpriteAnimationSet.cpp
  src/Sprite.cpp
  src/SpriteData.cpp
  src/StringResources.cpp
  src/Timer.cpp
  src/Transition.cpp
  src/TransitionFade.cpp
  src/TransitionImmediate.cpp
  src/TransitionScrolling.cpp
  src/Treasure.cpp

  src/third_party/hqx/hq2x.c
  src/third_party/hqx/hq3x.c
  src/third_party/hqx/hq4x.c
  src/third_party/hqx/init.c
  src/third_party/snes_spc/dsp.cpp
  src/third_party/snes_spc/SNES_SPC.cpp
  src/third_party/snes_spc/SNES_SPC_misc.cpp
  src/third_party/snes_spc/SNES_SPC_state.cpp
  src/third_party/snes_spc/spc.cpp
  src/third_party/snes_spc/SPC_DSP.cpp
  src/third_party/snes_spc/SPC_Filter.cpp

)

# Additional source files for Apple systems.
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(solarus_SOURCES
    ${solarus_SOURCES}
    src/lowlevel/apple/AppleInterface.mm
    include/solarus/lowlevel/apple/AppleInterface.h
  )
endif()

# Build the Solarus library.
add_library(solarus
  SHARED
  ${solarus_SOURCES}
)

target_link_libraries(solarus
  "${SDL2_LIBRARY}"
  "${SDL2_IMAGE_LIBRARY}"
  "${SDL2_TTF_LIBRARY}"
  "${OPENAL_LIBRARY}"
  "${LUA_LIBRARY}"
  "${DL_LIBRARY}"
  "${PHYSFS_LIBRARY}"
  "${VORBIS_LIBRARY}"
  "${VORBISFILE_LIBRARY}"
  "${OGG_LIBRARY}"
  "${MODPLUG_LIBRARY}"
)

set_target_properties(solarus PROPERTIES
  VERSION ${SOLARUS_VERSION_STRING}
  SOVERSION ${SOLARUS_MAJOR_VERSION}
)

# Configuration for OSX and iOS build and deployment.
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  if(NOT SOLARUS_IOS_BUILD)
    include(cmake/apple/OSXBuild.cmake)
  else()
    include(cmake/apple/iOSBuild.cmake)
  endif()
endif()

